;obrazovka.asm v. 1.00
;pro programovani zatrhnout security bity: SUT1; BODEN, CKOPT
.include	"m8515def.inc"			
.equ		TABULKA		=0x800
.equ		UVOD		=0x700
.def		REG0		=R0
.def		REG1		=R1
.def		ZACOBR1		=R2
.def		ZACOBR2		=R3
.def		MASKA		=R4
.def		BARVA		=R5
.def		TEMP0		=R6
.def		ZAPISBUF	=R7
.def		ZACPIS		=R8
.def		POZX1		=R9
.def		POZY1		=R10
.def		POZX2		=R11
.def		POZY2		=R12
.def		CTIBUF		=R13
.def		TYPRAD		=R14
.def		POSUV		=R15
;spodni 4 bity posuv X, horni bity posuv Y
.def		TEMP		=R16
.def		TEMP2		=R17
.def		TEMP3		=R18
.def		TEMP4		=R19
.def		TEMP5		=R20
.def		INTTEMP		=R21
.def		RADEK		=R22
.def		COUNTER		=R23
.def		ZNAK		=R24			
.def		STAV		=R25			
;u STAV.0 = kterou obrazovku zobrazuju (0 .. prvni; 1 .. druhou)
;       1 = pomocny priznak "zaporny Y" pouzivany pri zobrazeni usecky
;       1 = pomocny priznak "zaporny Y" pouzivany pri zobrazeni grafu
;		2 = vstupni priznak pro SAVEZNAK (0 .. dokresli; 1 .. prekresli)
; registry 26 a 31 jsou X,Y,Z!!!
.org		0x0000
			rjmp		RESET

;****************************************************************************
;preruseni od casovace pro synchronizacni impulsy a zobrazeni
.org		0x0004
			rjmp		CEKAM

.org		0x0005

;ulozi STATUS do zasobniku
MAININT:	in			INTTEMP,SREG	;1
			push		INTTEMP			;2

			sbic		PINB,0
			rjmp		TSNIMSYN


;synchronizace zapisoveho impulsu
TSNIMSYN:	sbrc		TYPRAD,3		;1/2
			rjmp		SNIMEK			;2
			sbrc		TYPRAD,0		;1/2
			rjmp		ZATEMNI1		;2
			sbrc		TYPRAD,2		;1/2
			rjmp		ZATEMNI2		;2
;synchro impuls
			cbi			PORTD,4			;2
			ldi			INTTEMP,16
DELL4uSD:	dec			INTTEMP
			brne		DELL4uSD
			sbi			PORTD,4
;test zatemnovacich radku
;zobrazeni datoveho radku 
			mov			INTTEMP,POSUV
			andi		INTTEMP,0x0F
			subi		INTTEMP,0xF0
DELLXuS:	nop								;1
			dec			INTTEMP				;1
			brne		DELLXuS				;2

;zapnuti hodin pro posuvne registry
			sbi			PORTB,1			;2
;			ldi			INTTEMP,0x19	;1
;			out			TCCR0,INTTEMP	;1

;data na obrazovku
			ld			INTTEMP,X			;4 usec	1-5
			st			X+,INTTEMP			;4 usec
			ld			INTTEMP,X
			st			X+,INTTEMP
			ld			INTTEMP,X
			st			X+,INTTEMP
			ld			INTTEMP,X
			st			X+,INTTEMP
			ld			INTTEMP,X
			st			X+,INTTEMP
			ld			INTTEMP,X				;6-10
			st			X+,INTTEMP
			ld			INTTEMP,X
			st			X+,INTTEMP
			ld			INTTEMP,X
			st			X+,INTTEMP
			ld			INTTEMP,X
			st			X+,INTTEMP
			ld			INTTEMP,X
			st			X+,INTTEMP
			ld			INTTEMP,X				;11-15
			st			X+,INTTEMP
			ld			INTTEMP,X
			st			X+,INTTEMP
			ld			INTTEMP,X
			st			X+,INTTEMP
			ld			INTTEMP,X
			st			X+,INTTEMP
			ld			INTTEMP,X
			st			X+,INTTEMP
			ld			INTTEMP,X				;16-20
			st			X+,INTTEMP
			ld			INTTEMP,X
			st			X+,INTTEMP
			ld			INTTEMP,X
			st			X+,INTTEMP
			ld			INTTEMP,X
			st			X+,INTTEMP
			ld			INTTEMP,X
			st			X+,INTTEMP
			ld			INTTEMP,X				;21-25
			st			X+,INTTEMP
			ld			INTTEMP,X
			st			X+,INTTEMP
			ld			INTTEMP,X
			st			X+,INTTEMP
			ld			INTTEMP,X
			st			X+,INTTEMP
			ld			INTTEMP,X
			st			X+,INTTEMP
			ld			INTTEMP,X				;26-30
			st			X+,INTTEMP
			ld			INTTEMP,X
			st			X+,INTTEMP
			ld			INTTEMP,X
			st			X+,INTTEMP
			ld			INTTEMP,X
			st			X+,INTTEMP
			ld			INTTEMP,X
			st			X+,INTTEMP
			ld			INTTEMP,X				;31-35
			st			X+,INTTEMP
			ld			INTTEMP,X
			st			X+,INTTEMP
			ld			INTTEMP,X
			st			X+,INTTEMP
			ld			INTTEMP,X
			st			X+,INTTEMP
			ld			INTTEMP,X
			st			X+,INTTEMP
			ld			INTTEMP,X				;36-40
			st			X+,INTTEMP
			ld			INTTEMP,X
			st			X+,INTTEMP
			ld			INTTEMP,X
			st			X+,INTTEMP
			ld			INTTEMP,X
			st			X+,INTTEMP
			ld			INTTEMP,X
			st			X+,INTTEMP
			ld			INTTEMP,X				;41-45
			st			X+,INTTEMP
			ld			INTTEMP,X
			st			X+,INTTEMP
			ld			INTTEMP,X
			st			X+,INTTEMP
			ld			INTTEMP,X
			st			X+,INTTEMP
			ld			INTTEMP,X
			st			X+,INTTEMP
			ld			INTTEMP,X				;46-50
			st			X+,INTTEMP
			ld			INTTEMP,X
			st			X+,INTTEMP
			ld			INTTEMP,X
			st			X+,INTTEMP
			ld			INTTEMP,X
			st			X+,INTTEMP
			ld			INTTEMP,X
			st			X+,INTTEMP
			ld			INTTEMP,X				;51-55
			st			X+,INTTEMP
			ld			INTTEMP,X
			st			X+,INTTEMP
			ld			INTTEMP,X
			st			X+,INTTEMP
			ld			INTTEMP,X
			st			X+,INTTEMP
			ld			INTTEMP,X
			st			X+,INTTEMP
			ld			INTTEMP,X				;56-60
			st			X+,INTTEMP
			ld			INTTEMP,X
			st			X+,INTTEMP
			ld			INTTEMP,X
			st			X+,INTTEMP
			ld			INTTEMP,X
			st			X+,INTTEMP
			ld			INTTEMP,X
			st			X+,INTTEMP
			ld			INTTEMP,X				;61-64
			st			X+,INTTEMP
			ld			INTTEMP,X
			st			X+,INTTEMP
			ld			INTTEMP,X
			st			X+,INTTEMP
			ld			INTTEMP,X
			st			X+,INTTEMP
			nop
			nop
			nop
;zastav posuvne registry
			cbi			PORTB,1
;testuju preteceni citace radku pres rozsah obrazovky
			sbrc		STAV,0
			rjmp		DRUHAOBR
;obsluha prvni obrazovky						
			sbrs		XH,6
			rjmp		TEST256RAD
			clr			XL
			ldi			XH,0x80
			rjmp		TEST256RAD
;obsluha druhe obrazovky
DRUHAOBR:	sbrc		XH,7
			rjmp		TEST256RAD
			clr			XL
			ldi			XH,0xC0
			rjmp		TEST256RAD
;je 256 radku hotovo?
TEST256RAD:	inc			RADEK
			brne		UKONCI
			lsl			TYPRAD			
UKONCI:		rjmp		INTEND
;zatemnovaci radky horni
ZATEMNI1:	nop
;synchro impuls
			cbi			PORTD,4			;2
			ldi			INTTEMP,16
DELL4uSDA:	dec			INTTEMP
			brne		DELL4uSDA
			sbi			PORTD,4

			inc			RADEK
			mov			INTTEMP,POSUV
			andi		INTTEMP,0xF0
			swap		INTTEMP
			subi		INTTEMP,0xDE
			cp			RADEK,INTTEMP			
			brne		INTEND
			clr			RADEK
			lsl			TYPRAD			
			rjmp		INTEND
;zatemnovaci radky spodni
ZATEMNI2:

;synchro impuls
			cbi			PORTD,4			;2
			ldi			INTTEMP,16
DELL4uSDB:	dec			INTTEMP
			brne		DELL4uSDB
			sbi			PORTD,4

			inc			RADEK
			mov			INTTEMP,POSUV
			andi		INTTEMP,0xF0
			swap		INTTEMP
			subi		INTTEMP,0x16
			neg			INTTEMP
			cp			RADEK,INTTEMP
			brne		INTEND
			clr			RADEK
			lsl			TYPRAD			
			rjmp		INTEND
;osetreni snimkoveho synchro impulsu
SNIMEK:		sbi			PORTD,3
			sbi			PORTD,4		;po dobu 4uS "1" pak "0"
			ldi			INTTEMP,16
DELL4uSU:	dec			INTTEMP
			brne		DELL4uSU
			cbi			PORTD,4			
			inc			RADEK		;osetreni citace radku
			cpi			RADEK,0x3			
			brne		INTEND
			clr			RADEK
			ldi			INTTEMP,0x1
			mov			TYPRAD,INTTEMP			

			sbrs		STAV,0
			mov			XH,ZACOBR1	;pocatecni misto pro vyber z pamneti
			sbrc		STAV,0
			mov			XH,ZACOBR2				
			clr			XL
			cbi			PORTD,3
;konec interuptu pro vsechny rezimy			
INTEND:		pop			INTTEMP
			out			SREG,INTTEMP
			reti

;****************************************************************************
;synchronizacni cekani na odstraneni vlivu delky instrukci
CEKAM:		sei
			push		TEMP				; 2
			in			TEMP,SREG			; 1
			push		TEMP				; 2 
			sbis		UCSRA,RXC			; 2 test prichoziho znaku
			rjmp		CEKAMC				; 2			
			inc			ZAPISBUF			; 1
			cp			ZAPISBUF,CTIBUF		; 1
			breq		CEKAMSUB			; 1
			push		ZL					; 2
			push		ZH					; 2
			dec			ZAPISBUF			; 1
			in			TEMP,UDR			; 1
			mov			ZL,ZAPISBUF			; 1
			ldi			ZH,0x1				; 1
			nop
			nop
			nop
			nop
			nop
			nop
			nop
			nop
			nop
			nop
			nop
			nop
			nop
			nop
			nop

			st			Z,TEMP				; 2
			inc			ZAPISBUF			; 1
			pop			ZH					; 2
			pop			ZL					; 2

			pop			TEMP
			out			SREG,TEMP
			pop			TEMP				; 2
			reti
CEKAMSUB:	dec			ZAPISBUF			; 1
			nop
			nop
			nop
			nop

			pop			TEMP
			out			SREG,TEMP
			pop			TEMP				; 2
			reti
CEKAMC:		nop
			nop
			nop
			nop
			nop
			nop
			nop
			nop
			nop
			nop

			pop			TEMP
			out			SREG,TEMP
			pop			TEMP				; 2
			reti

;****************************************************************************
;inicializace promennych po startu
RESET:		
;inicializace ukazatele zasobniku na konec adresy RAM
			ldi		 	TEMP,low(RAMEND)		
			out			SPL,TEMP			
			ldi		 	TEMP,high(RAMEND)
			out 		SPH,TEMP		
;inicializace vystupu portu	A-E		
			ldi			TEMP,0xFF 
			out			DDRA,TEMP
			ldi			TEMP,0xFF 
			out			DDRB,TEMP
			ldi			TEMP,0xFF 
			out			DDRC,TEMP
			out			DDRD,TEMP
			out			DDRE,TEMP
;nastaveni ostatnich promennych
			clr			ZAPISBUF
			clr			CTIBUF
			clr			RADEK			;pocitadlo a typ zobrazovanych radku
			ldi			TEMP,0xFF
			mov			BARVA,TEMP
			clr			STAV
;0x1 horni zat. 0x2 data, 0x4 dolni zat. 0x8 synchro
			ldi			TEMP,0x1
			mov			TYPRAD,TEMP			
;nastaveni pozice "kurzoru"
			clr			POZX1
			clr			POZY1
			clr			POZX2
			clr			POZY2
;inicializace komunikace s externi pameti
			ldi			TEMP,0xC0
			out			MCUCR,TEMP
			ldi			TEMP,0x44
			out			EMCUCR,TEMP
			ldi			TEMP,0x40
			out			SFIOR,TEMP

			ldi			TEMP,0x80
			mov			ZACOBR1,TEMP
			mov			ZACPIS,TEMP
			ldi			TEMP,0xC0
			mov			ZACOBR2,TEMP
;uvodni vymazani obrazovky
			cbi			PORTB,2
			ldi			TEMP,0xC0
			mov			ZACPIS,TEMP
			rcall		CLRSCR
			ldi			TEMP,0x80
			mov			ZACPIS,TEMP	
			rcall		CLRSCR
;inicializace seriove komunikace
			ldi			TEMP,0x4D		;nastaveni rychlosti prenosu na 9600
			out			UBRRL,TEMP
			clr			TEMP
			out			UBRRH,TEMP
			ldi			TEMP,0x10
			out			UCSRB,TEMP
			ldi			TEMP,0x86
			out			UCSRC,TEMP
;nacteni posunu obrazovky
EEPROMR:	sbic		EECR,EEWE
			rjmp		EEPROMR
			clr			TEMP
			out			EEARH,TEMP
			out			EEARL,TEMP
			sbi			EECR,EERE
			in			POSUV,EEDR
	
;*******************************
;nastaveni casovace pro preruseni
;casovac pro preruseni po 64us
			ldi			TEMP,0x02
			out			OCR1AH,TEMP
			ldi			TEMP,0xFD
			out			OCR1AL,TEMP
;casovac pro uvodni sesynchronizovani
			ldi			TEMP,0x00
			out			OCR1BH,TEMP
			ldi			TEMP,0x0F
			out			OCR1BL,TEMP
;nastaveni rezimu casovace
			ldi			TEMP,0x00
			out			TCCR1A,TEMP
			ldi			TEMP,0x9
			out			TCCR1B,TEMP
			ldi			TEMP,0x60
			out			TIMSK,TEMP
;nastaveni casovace pro hodiny posuvnych registru
			clr			TEMP
			out			TCNT0,TEMP
			out			OCR0,TEMP
			ldi			TEMP,0x19
			out			TCCR0,TEMP
;povoleni preruseni
			sei

;*******************************
;uvodni text na obrazovce
			ldi			ZL,0x0
			ldi			ZH,0xE
			rcall		VYPISTXT
			ldi			TEMP,0x0F
			mov			BARVA,TEMP
			rcall		VYPISTXT
			clr			BARVA
			com			BARVA
			rcall		VYPISTXT
			ldi			TEMP,0x0F0
			mov			BARVA,TEMP
			rcall		VYPISTXT
			ldi			TEMP,0x0F
			mov			BARVA,TEMP
			rcall		VYPISTXT
			clr			BARVA
			com			BARVA
			rcall		VYPISTXT
			ldi			TEMP,0x30
PLNTEMP2:	ldi			TEMP2,0xFF
PLNTEMP3:	ldi			TEMP3,0xFF
WAITCYKL:	dec			TEMP3
			brne		WAITCYKL
			dec			TEMP2
			brne		PLNTEMP3
			dec			TEMP
			brne		PLNTEMP2
			rcall		CLRSCR
			clr			POZX1
			clr			POZY1

;****************************************************************************
;*                           Hlavni smycka                                  *
;****************************************************************************
LOOP:		rcall		GETCH
			cpi			ZNAK,0x1B
			brne		NOESC
			rjmp		ESC
NOESC:		rcall		WRITE
			rjmp		LOOP

;tady zpracuju ESC prikaz
ESC:		rcall		GETCH
			ldi			TEMP,0xDF
			and			ZNAK,TEMP
			cpi			ZNAK,0x09			;TAB
			breq		ESCTABP
			cpi			ZNAK,0x42			;"B"
			breq		ESCBP
			cpi			ZNAK,0x43			;"C"
			breq		ESCCP
			cpi			ZNAK,0x47			;"G"
			breq		ESCGP
			cpi			ZNAK,0x48			;"H"
			breq		ESCHP
			cpi			ZNAK,0x4C			;"L"
			breq		ESCLP
			cpi			ZNAK,0x4D			;"M"
			breq		ESCMP
			cpi			ZNAK,0x4F			;"O"
			breq		ESCOP
			cpi			ZNAK,0x50			;"P"
			breq		ESCPP
			cpi			ZNAK,0x51			;"Q"
			breq		ESCQP
			cpi			ZNAK,0x52			;"R"
			breq		ESCRP
			cpi			ZNAK,0x53			;"S"
			breq		ESCSP
			cpi			ZNAK,0x54			;"T"
			breq		ESCTP
			cpi			ZNAK,0x55			;"U"
			breq		ESCUP
			cpi			ZNAK,0x56			;"V"
			breq		ESCVP
			cpi			ZNAK,0x57			;"W"
			breq		ESCWP
			cpi			ZNAK,0x58			;"X"
			breq		ESCXP
			cpi			ZNAK,0x59			;"Y"
			breq		ESCYP
			cpi			ZNAK,0x5A			;"Z"
			breq		ESCZP
			rjmp		LOOP

ESCTABP:	rjmp		ESCTAB
ESCBP:		rjmp		ESCB
ESCCP:		rjmp		ESCC
ESCGP:		rjmp		ESCG
ESCHP:		rjmp		ESCH
ESCLP:		rjmp		ESCL
ESCMP:		rjmp		ESCM
ESCOP:		rjmp		ESCO
ESCPP:		rjmp		ESCP
ESCQP:		rjmp		ESCQ
ESCRP:		rjmp		ESCR
ESCSP:		rjmp		ESCS
ESCTP:		rjmp		ESCT
ESCUP:		rjmp		ESCU
ESCVP:		rjmp		ESCV
ESCWP:		rjmp		ESCW
ESCXP:		rjmp		ESCX
ESCYP:		rjmp		ESCY
ESCZP:		rjmp		ESCZ


;*******************
;vodorovna cara
ESCT:		rcall		VEMXY
			mov			TEMP2,YL
			rcall		UPRAVXY
			rcall		GETCH				;ZNAK .. delka cary
			tst			ZNAK
			breq		ESCTEND
			ldi			TEMP,0x4
			sub			TEMP,TEMP3
			mov			TEMP3,TEMP
			clr			TEMP				;TEMP .. registr pro prvni 4 bity
			add			TEMP2,ZNAK			;kontrola preteceni
			brcc		ESCTOK
ESCTEND:	rjmp		LOOP
ESCTOK:		tst			TEMP3
			breq		ESCTC
			tst			ZNAK
			breq		ESCTOKA
			dec			TEMP3
			dec			ZNAK
			sec
			rol			TEMP				;postupne nasouva nahoru 0
			rjmp		ESCTOK
ESCTOKA:	dec			TEMP3
			clc
			rol			TEMP
			rjmp		ESCTOK

ESCTC:		mov			TEMP2,TEMP
			swap		TEMP
			or			TEMP,TEMP2
			and			TEMP,BARVA
			ld			TEMP2,Y
			or			TEMP2,TEMP
			st			Y+,TEMP2			;konec 1. bytu
			clr			TEMP
ESCTL:		cpi			ZNAK,0x4
			brlo		ESCTK
			ld			TEMP2,Y
			or			TEMP2,BARVA
			st			Y+,TEMP2
			subi		ZNAK,0x4
			rjmp		ESCTL				;konec prostredni casti
ESCTK:		tst			ZNAK
			breq		ESCTUK
			sec
			ror			TEMP
			dec			ZNAK
			rjmp		ESCTK	
ESCTUK:		mov			TEMP2,TEMP
			swap		TEMP
			or			TEMP,TEMP2
			and			TEMP,BARVA
			ld			TEMP2,Y
			or			TEMP2,TEMP
			st			Y,TEMP2
			rjmp		LOOP
;*******************
;svisla cara
ESCU:		rcall		VEMXY
			rcall		UPRAVXY
			mov			TEMP,ZNAK			
			rcall		GETCH				;ZNAK .. delka cary
			add			TEMP,ZNAK			;kontrola preteceni
			brcc		ESCUOK
ESCUEND:	rjmp		LOOP
ESCUOK:		ldi			TEMP,0x88			;TEMP .. maska pozice bitu
ESCUL:		tst			TEMP3				;upraveno podle zbytku v TEMP3
			breq		ESCUC
			lsr			TEMP
			dec			TEMP3
			rjmp		ESCUL
ESCUC:		and			TEMP,BARVA			;do TEMP pridana barva
ESCUML:		tst			ZNAK
			breq		ESCUEND
			ld			TEMP3,Y				;TEMP2 .. nactena hodnota
			or			TEMP3,TEMP
			st			Y+,TEMP3
			adiw		Y,0x3F
			dec			ZNAK
			rjmp		ESCUML
;*******************
;pevny zapis do pameti
ESCM:		rcall		GETCH
			mov			YH,ZNAK
			rcall		GETCH
			mov			YL,ZNAK
			rcall		GETCH
			mov			COUNTER,ZNAK
ESCMLOOP:	dec			COUNTER
			rcall		GETCH
			ori			YH,0x80
			st			Y+,ZNAK
			tst			COUNTER
			brne		ESCMLOOP
ESCMEND:	rjmp		LOOP
;*******************
;nastaveni posunu obrazu v horizontalnim smeru
ESCH:		rcall		GETCH
			andi		ZNAK,0x0F
			ldi			TEMP,0xF0
			and			POSUV,TEMP
			or			POSUV,ZNAK
			rjmp		ULOZEEP
;*******************
;nastaveni posunu obrazu v horizontalnim smeru
ESCO:		rcall		GETCH
			andi		ZNAK,0x0F
			swap		ZNAK
			ldi			TEMP,0x0F
			and			POSUV,TEMP
			or			POSUV,ZNAK
ULOZEEP:	sbic		EECR,EEWE
			rjmp		ULOZEEP
			clr			TEMP
			out			EEARH,TEMP
			out			EEARL,TEMP
			out			EEDR,POSUV
			cli
			sbi			EECR,EEMWE
			sbi			EECR,EEWE
			sei
			rjmp		LOOP

;*******************
;nastaveni pruhlednosti/nepruhlednosti znaku
ESCB:		rcall		GETCH
			cpi			ZNAK,0x30
			breq		ESCB0
			cpi			ZNAK,0x31
			breq		ESCB1
			rjmp		LOOP
ESCB0:		andi		STAV,0xFB
			rjmp		LOOP
ESCB1:		ori			STAV,0x04
			rjmp		LOOP
;*******************
;restart zarizeni
ESCQ:		rjmp		RESET
;*******************
;prehozeni ploch
ESCTAB:		sbrs		STAV,0
			rjmp		ESCTAB2
			andi		STAV,0xFE
			ldi			TEMP,0x80
			mov			ZACPIS,TEMP
			rjmp		LOOP
ESCTAB2:	ori			STAV,0x01
			ldi			TEMP,0xC0
			mov			ZACPIS,TEMP
			rjmp		LOOP

;*******************
;nastaveni zobrazovane plochy
ESCV:		rcall		GETCH
			cpi			ZNAK,0x31
			breq		ESCV1
			cpi			ZNAK,0x32
			breq		ESCV2
			rjmp		LOOP
ESCV1:		ldi			TEMP,0x8
ESCVL1:		cp			TYPRAD,TEMP
			brne		ESCVL1
			andi		STAV,0xFE
			rjmp		LOOP
ESCV2:		ldi			TEMP,0x8
ESCVL2:		cp			TYPRAD,TEMP
			brne		ESCVL2
			ori			STAV,0x01
			rjmp		LOOP
;*******************
;nastaveni plochy pro zapis
ESCW:		rcall		GETCH
			cpi			ZNAK,0x31
			breq		ESCW1
			cpi			ZNAK,0x32
			breq		ESCW2
			rjmp		LOOP
ESCW1:		ldi			TEMP,0x80
			mov			ZACPIS,TEMP
			rjmp		LOOP
ESCW2:		ldi			TEMP,0xC0
			mov			ZACPIS,TEMP
			rjmp		LOOP

;*******************
;vykresleni spojitych bodu
ESCG:		rcall		GETCH
			mov			YL,ZNAK					;YL .. aktualni X souradnice

			rcall		GETCH
			tst			ZNAK
			breq		ESCGEND

			mov			COUNTER,ZNAK			;COUNTER .. pocet vykreslovanych hodnot

			mov			TEMP,YL					;kontrola preteceni pres obrazovku v X
			add			TEMP,COUNTER
			brcs		ESCGEND

			rcall		GETCH					;YH .. "stara" Y souradnice
			mov			YH,ZNAK
			rcall		UPRAVXY
			
			ldi			TEMP,0x88				;TEMP .. maska pozice bitu
ESCGL:		tst			TEMP3					;upraveno podle zbytku v TEMP3
			breq		ESCGLOOP
			lsr			TEMP
			dec			TEMP3
			rjmp		ESCGL

ESCGEND:	rjmp		LOOP

ESCGLOOP:	dec			COUNTER
			tst			COUNTER
			breq		ESCGEND

			mov			TEMP2,ZNAK				;TEMP2 .. zaloha stare Y pozice

			rcall		GETCH					;ZNAK .. aktualni Y souradnice

			cp			TEMP2,ZNAK				;rozskok, podle pozic
			brlo		ESCGD

			mov			TEMP3,TEMP2				;TEMP3 .. delka 1. svisle cary
			sub			TEMP3,ZNAK
			clr			TEMP4
			lsr			TEMP3
			rol			TEMP4					;TEMP4 .. zbytek TEMP3 / 2
			add			TEMP4,TEMP3				;TEMP4 .. delka 2. svisle cary

			mov			TEMP0,TEMP
			and			TEMP0,BARVA

ESCGU1:		ld			TEMP5,Y
			or			TEMP5,TEMP0
			st			Y,TEMP5
			tst			TEMP3
			breq		ESCGU2
			dec			TEMP3
			sbiw		Y,0x20
			sbiw		Y,0x20
			rjmp		ESCGU1

ESCGU2:		lsr			TEMP
			brcc		ESCGU4
			ldi			TEMP,0x88
			adiw		Y,0x1

ESCGU4:		mov			TEMP0,TEMP
			and			TEMP0,BARVA

ESCGU3:		tst			TEMP4
			breq		ESCGLOOP
			dec			TEMP4
			ld			TEMP5,Y
			or			TEMP5,TEMP0
			st			Y,TEMP5
			sbiw		Y,0x20
			sbiw		Y,0x20
			rjmp		ESCGU3

ESCGD:		mov			TEMP3,ZNAK				;TEMP3 .. delka 1. svisle cary
			sub			TEMP3,TEMP2
			clr			TEMP4
			lsr			TEMP3
			rol			TEMP4					;TEMP4 .. zbytek TEMP3 / 2
			add			TEMP4,TEMP3				;TEMP4 .. delka 2. svisle cary

			mov			TEMP0,TEMP
			and			TEMP0,BARVA

ESCGD1:		ld			TEMP5,Y
			or			TEMP5,TEMP0
			st			Y,TEMP5
			tst			TEMP3
			breq		ESCGD2
			dec			TEMP3
			adiw		Y,0x20
			adiw		Y,0x20
			rjmp		ESCGD1

ESCGD2:		lsr			TEMP
			brcc		ESCGD4
			ldi			TEMP,0x88
			adiw		Y,0x1

ESCGD4:		mov			TEMP0,TEMP
			and			TEMP0,BARVA
ESCGD3:		tst			TEMP4
			breq		ESCGLOOP
			dec			TEMP4
			ld			TEMP5,Y
			or			TEMP5,TEMP0
			st			Y,TEMP5
			adiw		Y,0x20
			adiw		Y,0x20
			rjmp		ESCGD3


;*******************
;nastaveni barvy
ESCC:		rcall		GETCH
			mov			BARVA,ZNAK
			rjmp		LOOP
;*******************
;vykresleni usecky
ESCL:		rcall		GETCH
			mov			TEMP4,ZNAK			;TEMP4 .. "X1"
			rcall		GETCH
			mov			TEMP5,ZNAK			;TEMP5 .. "Y1"
			rcall		VEMXY				;YL .. "X2"; YH .. "Y2"
			cp			YL,TEMP4
			brcs		ESCLSOURY
			mov			TEMP,YL				;pokud je X1>X2, prohodim oba body, aby v YL/H byl pocatecni bod
			mov			YL,TEMP4
			mov			TEMP4,TEMP
			mov			TEMP,YH
			mov			YH,TEMP5
			mov			TEMP5,TEMP
ESCLSOURY:	ldi			TEMP,0x02			;test, zda je Y1<Y2 - pak je v Y ose prirustek
			or			STAV,TEMP			;jinak je ubytek => priznak "zaporne Y"
			cp			TEMP5,YH
			brcs		ESCLDELTA
			ldi			TEMP,0xFD
			and			STAV,TEMP
ESCLDELTA:	sub			TEMP4,YL			;TEMP4 .. "dX"
			sbrs		STAV,1
			rjmp		ESCLSUB
			mov			TEMP,YH
			sub			TEMP,TEMP5			;TEMP5 .. "dY"
			mov			TEMP5,TEMP
			rjmp		ESCLN
ESCLSUB:	sub			TEMP5,YH
ESCLN:		mov			TEMP3,TEMP5			;TEMP3 .. "N" .. pocet pixelu
			cp			TEMP5,TEMP4
			brcc		ESCLKROK
			mov			TEMP3,TEMP4

ESCLKROK:	tst			TEMP4				;test deleni nulou
			breq		ESCLX0DIV

			mov			TEMP,TEMP3			;krokX:=N div dx
			clr			TEMP2
ESCLKROKL1:	sub			TEMP,TEMP4
			brlo		ESCLKROK2
			inc			TEMP2				;TEMP2 .. krokX
			rjmp		ESCLKROKL1
ESCLKROK2:	add			TEMP,TEMP4
			mov			REG0,TEMP			;REG0 .. zbytekX
			rjmp		ESCLX0DIE
ESCLX0DIV:	ldi			TEMP2,0xFF
			clr			REG0

ESCLX0DIE:	tst			TEMP5				;test deleni nulou
			breq		ESCLY0DIV

			mov			TEMP,TEMP3			;krokY:=N div dy
			clr			TEMP0
ESCLKROKL2:	sub			TEMP,TEMP5
			brlo		ESCLZAPOR
			inc			TEMP0				;TEMP0 .. krokY
			rjmp		ESCLKROKL2
ESCLZAPOR:	add			TEMP,TEMP5
			mov			REG1,TEMP			;REG1 .. zbytekY
			rjmp		ESCLY0DIE
ESCLY0DIV:	clr			TEMP0
			dec			TEMP0
			clr			REG1

ESCLY0DIE:	cp			REG0,TEMP2			;porovnani zbytkuX a krokuX
			brcs		ECSLNODELX

			mov			TEMP,TEMP3			;zbytekX:=N div zbytekX
			mov			COUNTER,REG0
			clr			REG0
ESCLZBL1:	sub			TEMP,COUNTER
			brlo		ESCLZB2
			inc			REG0				;REG0 .. pomocny krok zbytkuX
			rjmp		ESCLZBL1

ECSLNODELX:	ldi			TEMP,0xFF
			mov			REG0,TEMP

ESCLZB2:	cp			REG1,TEMP0			;porovnani zbytkuY a krokuY
			brcs		ECSLNODELY

			mov			TEMP,TEMP3			;zbytekY:=N div zbytekY
			mov			COUNTER,REG1
			clr			REG1
ESCLZBL2:	sub			TEMP,COUNTER
			brlo		ESCLINCI
			inc			REG1				;REG1 .. pomocny krok zbytkuY
			rjmp		ESCLZBL2

ECSLNODELY:	ldi			TEMP,0xFF
			mov			REG1,TEMP

ESCLINCI:	clr			COUNTER				;COUNTER .. pocitadlo krokuX
			clr			ZNAK				;ZNAK .. pocitadlo krokuY
			clr			ZL					;ZL .. pocitadlo zbytkuX
			clr			ZH					;ZH .. pocitadlo zbytkuY

ESCLOOP:	tst			TEMP3
			breq		ESCLEND
			dec			TEMP3

			inc			COUNTER
			inc			ZNAK
			inc			ZL
			inc			ZH

			cp			COUNTER,TEMP2
			brne		ESCLL2
			inc			YL
			clr			COUNTER
ESCLL2:		cp			ZNAK,TEMP0
			brne		ESCLL3
			clr			ZNAK
			sbrc		STAV,1
			dec			YH
			sbrs		STAV,1
			inc			YH
ESCLL3:		cp			ZL,REG0
			brne		ESCLL4
			inc			YL
			clr			ZNAK
ESCLL4:		cp			ZH,REG1
			brne		ESCLL5
			clr			ZH
			sbrc		STAV,1
			dec			YH
			sbrs		STAV,1
			inc			YH

ESCLL5:		push		TEMP2				;vykresleni bodu
			push		TEMP3
			push		TEMP4
			push		YL
			push		YH
			rcall		UPRAVXY
			rcall		POINT
			pop			YH
			pop			YL
			pop			TEMP4
			pop			TEMP3
			pop			TEMP2
			rjmp		ESCLOOP
ESCLEND:	rjmp		LOOP

;*******************
;vykresleni plneho obdelniku
ESCR:		rcall		VEMXY
			rcall		GETCH				
			mov			TEMP,ZNAK			;TEMP4 .. velikost strany X
			mov			TEMP4,TEMP
			add			TEMP,YL
			brcc		ESCRY
			mov			TEMP4,YL
			com			TEMP4
ESCRY:		rcall		GETCH
			mov			TEMP,ZNAK			;TEMP5 .. velikost strany Y
			mov			TEMP5,TEMP
			add			TEMP,YH
			brcc		ESCRC
			mov			TEMP5,YH
			com			TEMP5
ESCRC:		rcall		UPRAVXY				;TEMP3 .. zbytek (posun v ramci Bytu)
			mov			ZH,YH
			mov			ZL,YL
			mov			TEMP,TEMP3			;uprava zbytku v TEMP3 na "4-zbytek"
			ldi			TEMP3,0x04			;budeme posouvat doleva o tolik pixelu
			sub			TEMP3,TEMP
			clr			TEMP2			
			sub			TEMP4,TEMP3			;TEMP4 .. zmenseni velikosti strany o zbytek
			brcc		ESCRZZ
			add			TEMP4,TEMP3
			sub			TEMP3,TEMP4
			clr			TEMP0
ESCRMA:		subi		TEMP4,0x01
			brlo		ESCRMB
			sec
			rol			TEMP0
			rjmp		ESCRMA				
ESCRMB:		subi		TEMP3,0x01
			brlo		ESCRMC
			lsl			TEMP0
			rjmp		ESCRMB
ESCRMC:		clr			TEMP4
			clr			TEMP2
			mov			TEMP,TEMP0
			swap		TEMP
			or			TEMP0,TEMP
			rjmp		ESCRLOOP
ESCRZZ:		subi		TEMP4,0x04
			brlo		ESCRZZK
			inc			TEMP2
			rjmp		ESCRZZ				;TEMP2 .. pocet Bytu
ESCRZZK:	ldi			TEMP,0x04			
			add			TEMP4,TEMP			;TEMP4 .. konecny zbytek
			clr			TEMP0
			mov			TEMP,TEMP3
ESCRZZA:	subi		TEMP,0x01
			brlo		ESCRZZAK
			sec
			rol			TEMP0
			rjmp		ESCRZZA				
ESCRZZAK:	mov			TEMP,TEMP0
			swap		TEMP
			or			TEMP0,TEMP			;TEMP0 .. maska pro prvni Byte
			clr			TEMP
ESCRKZ:		subi		TEMP4,0x01
			brlo		ESCRZKK
			sec
			ror			TEMP
			rjmp		ESCRKZ
ESCRZKK:	mov			TEMP4,TEMP
			swap		TEMP
			or			TEMP4,TEMP			;TEMP4 .. maska konecneho Byte
ESCRLOOP:	subi		TEMP5,0x01
			brlo		ZPETLOOP
			mov			YL,ZL
			mov			YH,ZH
			adiw		Z,0x20
			adiw		Z,0x20
			ld			TEMP,Y
			mov			MASKA,TEMP0
			com			MASKA
			and			TEMP,MASKA
			mov			MASKA,TEMP0
			and			MASKA,BARVA
			or			TEMP,MASKA
			st			Y+,TEMP
			mov			TEMP,TEMP2
ESCRSTRED:	subi		TEMP,0x01
			brlo		ESCREND
			st			Y+,BARVA
			rjmp		ESCRSTRED
ESCREND:	ld			TEMP,Y
			mov			MASKA,TEMP4
			com			MASKA
			and			TEMP,MASKA
			mov			MASKA,TEMP4
			and			MASKA,BARVA
			or			TEMP,MASKA
			st			Y,TEMP
			rjmp		ESCRLOOP
ZPETLOOP:	rjmp		LOOP
;*******************
;vykresleni jednoho bodu
ESCP:		rcall		VEMXY
			rcall		UPRAVXY
			rcall		POINT
			rjmp		LOOP
POINT:		ldi			TEMP2,0x88
			and			TEMP2,BARVA
			ldi			TEMP4,0x77
ESCPLOOP:	tst			TEMP3
			breq		ESCPCON
			lsr			TEMP2
			sec
			ror			TEMP4
			dec			TEMP3
			rjmp		ESCPLOOP
ESCPCON:	ld			TEMP,Y
			and			TEMP,TEMP4
			or			TEMP,TEMP2
			st			Y,TEMP
			ret
;*******************
;vymazani obrazovky
ESCS:		rcall		CLRSCR
			sbrc		ZACPIS,6
			rjmp		ESCSB
			clr			POZX1
			clr			POZY1
			rjmp		LOOP
ESCSB:		clr			POZX2
			clr			POZY2
			rjmp		LOOP
;*******************
;nastaveni x pozice kursoru
ESCX:		rcall		GETCH
			cpi			ZNAK,0x2A
			brcs		ESCX2
			rjmp		LOOP
ESCX2:		ldi			TEMP,0x06
			mul			TEMP,ZNAK
			sbrs		ZACPIS,6
			mov			POZX1,REG0
			sbrc		ZACPIS,6
			mov			POZX2,REG0
			rjmp		LOOP
;*******************
;nastaveni y pozice kursoru
ESCY:		rcall		GETCH
			cpi			ZNAK,0x20
			brcs		ESCY2
			rjmp		LOOP
ESCY2:		ldi			TEMP,0x08
			mul			TEMP,ZNAK
			sbrs		ZACPIS,6
			mov			POZY1,REG0
			sbrc		ZACPIS,6
			mov			POZY2,REG0
			rjmp		LOOP
;*******************
;vypise velky znak
ESCZ:		rcall		GETCH
			cpi			ZNAK,0xEB
			brcc		ESCZK2
			mov			YL,ZNAK								

			rcall		GETCH
			cpi			ZNAK,0xE3
			brcc		ESCZK1
			mov			YH,ZNAK								


			lsr			YH
			ror			YL
			lsr			YH
			ror			YL

			sbrs		STAV,0
			ldi			TEMP,0x80
			sbrc		STAV,0
			ldi			TEMP,0xC0
			add			YH,TEMP

			rcall		GETCH

			ldi			TEMP,8			;nastaveni zacatku znaku v tabulce znaku
			mul			TEMP,ZNAK
			ldi			TEMP,0x10
			add			R1,TEMP
			movw		ZL,R0
	
			ldi			TEMP,7			;presouvam znaky
DALSIRADEK:	ldi			COUNTER,4

			lpm			TEMP2,Z+		;vyber z tabulky znaku 1 Byte

YBITY:		clr			TEMP4
			sbrc		TEMP2,7
			mov			TEMP4,BARVA
			st			Y+,TEMP4

			clr			TEMP4
			sbrc		TEMP2,6
			mov			TEMP4,BARVA
			st			Y+,TEMP4

			clr			TEMP4
			sbrc		TEMP2,5
			mov			TEMP4,BARVA
			st			Y+,TEMP4

			clr			TEMP4
			sbrc		TEMP2,4
			mov			TEMP4,BARVA
			st			Y+,TEMP4

			clr			TEMP4
			sbrc		TEMP2,3
			mov			TEMP4,BARVA
			st			Y+,TEMP4

			adiw		Y,59		; tady bylo YL
			dec			COUNTER
			brne		YBITY
			dec			TEMP
			brne		DALSIRADEK
			rjmp		LOOP

ESCZK2:		rcall		GETCH
ESCZK1:		rcall		GETCH
			rjmp		LOOP

;****************************************************************************
;podprogramy

;ceka na prichod znaku, ulozi ho do ZNAK
;vstup dat: ---
;pouziva: --- 
;vola: ---
GETCH:		cp			ZAPISBUF,CTIBUF		; 1
			breq		GETCH				; 1
			push		ZL					; 2
			push		ZH					; 2
			mov			ZL,CTIBUF			; 1
			ldi			ZH,0x1				; 1
			ld			ZNAK,Z				; 2
			inc			CTIBUF				; 1
			pop			ZH					; 2
			pop			ZL					; 2
			ret


;vypise na obrazovku znak a upravi POZX, POZY
;vstup dat: ZNAK, POZX, POZY
;pouziva: TEMP, 
;vola: SAVEZNAK
FORMFEED1:	sbrc		ZACPIS,6
			rjmp		FORMFEED1A
			clr			POZX1
			clr			POZY1
			rjmp		CLRSCR
FORMFEED1A:	clr			POZX2
			clr			POZY2
			rjmp		CLRSCR
WRITE:		sbrc		ZACPIS,6
			rjmp		WRITE2
;OBRAZOVKA1
WRITE1:		cpi			ZNAK,0x8			;testuju BACKSPACE
			breq		BACKSPACE1
			cpi			ZNAK,0x0C			;testuju FORMFEED
			breq		FORMFEED1
			cpi			ZNAK,0x9			;testuju TAB
			breq		TAB1
			cpi			ZNAK,0xA			;testuju LineFeed
			breq		KONECFCE
			cpi			ZNAK,0xD			;testuju ENTER
			breq		ENTER1
			rcall		SAVEZNAK
; test, zda zbyva misto pro posun na radku 6 je zapsany znak + na dalsi volny
			ldi			TEMP,14
			add			TEMP,POZX1
			brcc		PRICTIPOZ1
; neni misto, musim posunou radek na dalsi
ENTER1:		clr			POZX1
			ldi			TEMP,8
			add			POZY1,TEMP
; pokud jsem se nedostal na 248, muzu ukoncit
			brcc		ENDWRITE1		
; musim pouzit nejstarsi radek
			clr			YL				;mazu nejstarsi zobrazovany radek
			mov			YH,ZACOBR1
			clr			TEMP
			clr			TEMP2
CLRBYTE1:	st			Y+,TEMP2
			st			Y+,TEMP2
			dec			TEMP
			brne		CLRBYTE1
; radek je vymazany, musim odrolovat obrazovku
			inc			ZACOBR1			;roluju obrazovku 2x
			inc			ZACOBR1			
; a kontroluju, zda nejsem pres C000hex
			sbrs		YH,6			
			rjmp		SETPOZY1
			ldi			TEMP,0x80
			mov			ZACOBR1,TEMP
; ukazatel Y nechavam na plne obrazovce = 248 linka
SETPOZY1:	ldi			TEMP,248
			mov			POZY1,TEMP
ENDWRITE1:	ret
PRICTIPOZ1:	ldi			TEMP,6
			add			POZX1,TEMP
KONECFCE:	ret
;obsluha tabulatoru
TAB1:		ldi			TEMP,40			;testuju zda je misto pro posledni TAB
			add			TEMP,POZX1
			brcc		TABRUN1
			ret
TABRUN1:	clr			TEMP
			ldi			TEMP2,36		
TABLOOP1:	add			TEMP,TEMP2
			mov			TEMP3,POZX1
			sub			TEMP3,TEMP			
			brcc		TABLOOP1
			mov			POZX1,TEMP
			ret
;obsluha backspace
BACKSPACE1:	mov			TEMP,POZX1
			subi		TEMP,0x06
			brcc		BACKRUN1
			ret
BACKRUN1:	mov			POZX1,TEMP
			push		STAV
			andi		STAV,0xFB
			rcall		SAVEZNAK
			pop			STAV
			ret		
;*****************************
;OBRAZOVKA2	
FORMFEED2:	sbrc		ZACPIS,6
			rjmp		FORMFEED2A
			clr			POZX1
			clr			POZY1
			rjmp		CLRSCR
FORMFEED2A:	clr			POZX2
			clr			POZY2
			rjmp		CLRSCR
WRITE2:		cpi			ZNAK,0x8			;testuju BACKSPACE
			breq		BACKSPACE2
			cpi			ZNAK,0xC			;testuju FORMFEED
			breq		FORMFEED2
			cpi			ZNAK,0x9			;testuju TAB
			breq		TAB2
			cpi			ZNAK,0xA			;testuju LineFeed
			breq		KONECFCE
			cpi			ZNAK,0xD			;testuju ENTER
			breq		ENTER2
			rcall		SAVEZNAK
; test, zda zbyva misto pro posun na radku 6 je zapsany znak + na dalsi volny
			ldi			TEMP,14
			add			TEMP,POZX2
			brcc		PRICTIPOZ2
; neni misto, musim posunou radek na dalsi
ENTER2:		clr			POZX2
			ldi			TEMP,8
			add			POZY2,TEMP
; pokud jsem se nedostal na 248, muzu ukoncit
			brcc		ENDWRITE2		
; musim pouzit nejstarsi radek
			clr			YL				;mazu nejstarsi zobrazovany radek
			mov			YH,ZACOBR2
			clr			TEMP
			clr			TEMP2
CLRBYTE2:	st			Y+,TEMP2
			st			Y+,TEMP2
			dec			TEMP
			brne		CLRBYTE2
; radek je vymazany, musim odrolovat obrazovku
			inc			ZACOBR2			;roluju obrazovku 2x
			inc			ZACOBR2			
; a kontroluju, zda nejsem pres FFFF hex
			sbrc		YH,7			
			rjmp		SETPOZY2
			ldi			TEMP,0xC0
			mov			ZACOBR2,TEMP
; ukazatel Y nechavam na plne obrazovce = 248 linka
SETPOZY2:	ldi			TEMP,248
			mov			POZY2,TEMP
ENDWRITE2:	ret
PRICTIPOZ2:	ldi			TEMP,6
			add			POZX2,TEMP
			ret
;obsluha tabulatoru
TAB2:		ldi			TEMP,40			;testuju zda je misto pro posledni TAB
			add			TEMP,POZX2
			brcc		TABRUN2
			ret
TABRUN2:	clr			TEMP
			ldi			TEMP2,36		
TABLOOP2:	add			TEMP,TEMP2
			mov			TEMP3,POZX2
			sub			TEMP3,TEMP			
			brcc		TABLOOP2
			mov			POZX2,TEMP
			ret
;obsluha backspace
BACKSPACE2:	mov			TEMP,POZX2
			subi		TEMP,6
			brcc		BACKRUN2
			ret
BACKRUN2:	mov			POZX2,TEMP
			push		STAV
			andi		STAV,0xFB
			rcall		SAVEZNAK
			pop			STAV
			ret		
;vybere s tabulky a ulozi do externi pamneti znak
;vstup dat: Z(pozice pro vyber z tabulky), Y(pozice pro ulozeni do ext pamneti),
;			ZNAK, POZX, POZY
;pouziva: TEMP, TEMP2, TEMP3, TEMP4, MASKA
SAVEZNAK:	clr			TEMP3
			sbrc		ZACPIS,6			;rozhodnuti pro kterou obrazovku se ma kreslit
			rjmp		SAVEOBR2
			mov			YL,POZX1
			mov			YH,POZY1
			rjmp		SAVEZNAKU
SAVEOBR2:	mov			YL,POZX2			
			mov			YH,POZY2
SAVEZNAKU:	lsr			YH					;Y .. Y div 4
			ror			YL
			lsr			YH
			ror			YL			
			ror			TEMP3				;TEMP3.7 .. priznak pro posun
			ldi 		TEMP,0x00			;MASKA .. maska pro prvni Byte
			sbrc		TEMP3,7
			ldi			TEMP,0xCC
			mov			MASKA,TEMP
			ldi			TEMP,0x33
			sbrc		TEMP3,7
			ldi			TEMP,0x00
			mov			TEMP3,TEMP			;TEMP3 .. maska pro druhy Byte
;uprava pozice pro ulozeni do pameti
			sbrc		ZACPIS,6			
			rjmp		SAVEINI2
			add			YH,ZACOBR1
; ted musi testovat, zda nejsem pres rozsah 16kB video pameti
			sbrs		YH,6
			rjmp		SETPAM
			ldi			TEMP,0xBF			
			and			YH,TEMP					
			rjmp		SETPAM
SAVEINI2:	add			YH,ZACOBR2
;ted musi testovat, zda nejsem pres rozsah 16kB video pameti
			sbrc		YH,7
			rjmp		SETPAM
			ldi			TEMP,0xC0			
			or			YH,TEMP					
;vyber znaku z tabulky + priprava adresy do Z
SETPAM:		ldi			TEMP,8			;nastaveni zacatku znaku v tabulce znaku
			mul			TEMP,ZNAK
			ldi			TEMP,0x10
			add			R1,TEMP
			movw		ZL,R0
			ldi			TEMP,0x8			
			mov			TEMP0,TEMP	;presouvam znaky - pocitadlo osmi radku
;zde zacina smycka
LOADZNAK:	lpm			TEMP2,Z+		;TEMP2 .. zobrazovana data
			andi		TEMP2,0xFC
			sbrc		TEMP3,0
			rjmp		LOADZNAKA		
			lsr			TEMP2			;korekce dat v TEMP2 podle posunuti
			lsr			TEMP2			
LOADZNAKA:	mov			TEMP4,TEMP2	
			andi		TEMP4,0x0F		;TEMP4 .. data pro druhy Byte
			mov			TEMP,TEMP4
			swap		TEMP
			or			TEMP4,TEMP
			andi		TEMP2,0xF0		;TEMP2 .. data pro prvni Byte
			mov			TEMP,TEMP2
			swap		TEMP
			or			TEMP2,TEMP
			ld			TEMP,Y
			sbrs		STAV,2
			and			TEMP,MASKA
			and			TEMP2,BARVA
			or			TEMP,TEMP2
			st			Y+,TEMP			;ulozeni prvniho Bytu
			ld			TEMP,Y
			sbrs		STAV,2
			and			TEMP,TEMP3
			and			TEMP4,BARVA
			or			TEMP,TEMP4
			st			Y+,TEMP			;ulozeni druheho Bytu
			adiw		Y,0x3E
			dec			TEMP0
			brne		LOADZNAK
			ret




;podprogram pro vymazani obrazovky
;vstup dat: -
;pouziva: TEMP, TEMP2, TEMP3, Y
CLRSCR:		mov			YH,ZACPIS			;pocatecni misto pro vyber z pamneti
			sbrc		ZACPIS,6
			mov			ZACOBR2,YH
			sbrs		ZACPIS,6
			mov			ZACOBR1,YH
			ldi			YL,0x00
			clr			TEMP3
			ldi			TEMP2,64
DATA1:		clr			TEMP				;provede 64 znaku x 256 radku
DATA2:		st			Y+,TEMP3			;tam kde ukazuje Y sype 0
			dec			TEMP				
			brne		DATA2				
			dec			TEMP2				
			brne		DATA1				
			ret

;podprogram pro nasteni souradnic X a Y,
;vystup dat: Y .. adresa pameti; TEMP3 .. zbytek po deleni 4 (posun v Bytu)
;vstup dat: -
;pouziva: TEMP3, Y, GETCH
VEMXY	:	rcall		GETCH
			mov			YL,ZNAK								
			rcall		GETCH
			mov			YH,ZNAK								
			ret
UPRAVXY:	clr			TEMP3
			lsr			YH
			ror			YL
			ror			TEMP3
			lsr			YH
			ror			YL
			rol			TEMP3
			rol			TEMP3

			sbrs		ZACPIS,6
			ldi			TEMP,0x80
			sbrc		ZACPIS,6
			ldi			TEMP,0xC0
			add			YH,TEMP
			ret


;****************
;slouzi k vypsani textu na obrazovku
;vstup dat: Z .. ukazatel do tabulky na text ukonceny 0x00
;vystup dat: -
;pouziva: ZNAK, Z,

VYPISTXT:	lpm			ZNAK,Z+
			tst			ZNAK
			breq		VYPISTXTE
			push		ZL
			push		ZH
			rcall		WRITE
			pop			ZH
			pop			ZL
			rjmp		VYPISTXT
VYPISTXTE:	ret

;****************************************************************************
;uvodni vypis
.org		UVOD
.dw			0x6C41					;Al
.dw			0x6870					;ph
.dw			0x6E61					;an
.dw			0x6D75					;um
.dw			0x7265					;er
.dw			0x6369					;ic
.dw			0x2620					;&
.dw			0x6720					;g
.dw			0x6172					;ra
.dw			0x6870					;ph
.dw			0x6369					;ic
.dw			0x5420					;T
.dw			0x2056					;V
.dw			0x6964					;di
.dw			0x7073					;sp
.dw			0x616C					;la
.dw			0x0D79					;y
.dw			0x4900					;I
.dw			0x706E					;np
.dw			0x7475					;ut
.dw			0x203A					;:
.dw			0x5352					;RS
.dw			0x3332					;23
.dw			0x2C32					;2,
.dw			0x3920					;9
.dw			0x3036					;60
.dw			0x2030					;0
.dw			0x6442					;bd
.dw			0x0D2C					;,
.dw			0x2020
.dw			0x2020
.dw			0x2020
.dw			0x3820					;8
.dw			0x6220					;b
.dw			0x7469					;it
.dw			0x2C73					;s,
.dw			0x6E20					;n
.dw			0x206F					;o
.dw			0x6170					;pa
.dw			0x6972					;ri
.dw			0x7974					;ty
.dw			0x202C					;,
.dw			0x200D
.dw			0x2020
.dw			0x2020
.dw			0x2020
.dw			0x2032					;2
.dw			0x7473					;st
.dw			0x706F					;op
.dw			0x6220					;b
.dw			0x7469					;it
.dw			0x2073					;s
.dw			0x320D					;2
.dw			0x3635					;56
.dw			0x3278					;x2
.dw			0x3635					;56
.dw			0x7020					;p
.dw			0x7869					;ix
.dw			0x6C65					;el
.dw			0x202C					;,
.dw			0x6F66					;fo
.dw			0x7275					;ur
.dw			0x6320					;c
.dw			0x6C6F					;ol
.dw			0x726F					;or
.dw			0x2073					;s 
.dw			0xB200					; 
.dw			0xB200					; 
.dw			0xB200					; 
.dw			0x0D00					; 
.dw			0x280D					;(
.dw			0x2963					;c)
.dw			0x5220					;R
.dw			0x6461					;ad
.dw			0x6D69					;im
.dw			0x5020					;P
.dw			0x6365					;ec
.dw			0x6168					;ha
.dw			0x2C6C					;l,
.dw			0x7220					;r
.dw			0x6461					;ad
.dw			0x6D69					;im
.dw			0x702E					;.p
.dw			0x6365					;ec
.dw			0x6168					;ha
.dw			0x406C					;l@
.dw			0x6573					;se
.dw			0x6E7A					;zn
.dw			0x6D61					;am
.dw			0x632E					;.c
.dw			0x0D7A					;z
.dw			0x7468					;ht
.dw			0x7074					;tp
.dw			0x2F3A					;:/
.dw			0x722F					;/r
.dw			0x6461					;ad
.dw			0x6D69					;im
.dw			0x782E					;.x
.dw			0x2E66					;f.
.dw			0x7A63					;cz
.dw			0x0000					;















;tabulka znaku

.org		TABULKA
.dw			0xF8F8					;netisknutelny znak 
.dw			0xF8F8
.dw			0xF8F8
.dw			0x00F8

.dw			0xF8F8					;netisknutelny znak 
.dw			0xF8F8
.dw			0xF8F8
.dw			0x00F8

.dw			0xF8F8					;netisknutelny znak 
.dw			0xF8F8
.dw			0xF8F8
.dw			0x00F8

.dw			0xF8F8					;netisknutelny znak 
.dw			0xF8F8
.dw			0xF8F8
.dw			0x00F8

.dw			0xF8F8					;netisknutelny znak 
.dw			0xF8F8
.dw			0xF8F8
.dw			0x00F8

.dw			0xF8F8					;netisknutelny znak 
.dw			0xF8F8
.dw			0xF8F8
.dw			0x00F8

.dw			0xF8F8					;netisknutelny znak 
.dw			0xF8F8
.dw			0xF8F8
.dw			0x00F8

.dw			0xF8F8					;netisknutelny znak 
.dw			0xF8F8
.dw			0xF8F8
.dw			0x00F8

.dw			0x0000					;backspace
.dw			0x0000
.dw			0x0000
.dw			0x0000

.dw			0xF8F8					;netisknutelny znak 
.dw			0xF8F8
.dw			0xF8F8
.dw			0x00F8

.dw			0xF8F8					;netisknutelny znak 
.dw			0xF8F8
.dw			0xF8F8
.dw			0x00F8

.dw			0xF8F8					;netisknutelny znak 
.dw			0xF8F8
.dw			0xF8F8
.dw			0x00F8

.dw			0xF8F8					;netisknutelny znak 
.dw			0xF8F8
.dw			0xF8F8
.dw			0x00F8

.dw			0xF8F8					;netisknutelny znak 
.dw			0xF8F8
.dw			0xF8F8
.dw			0x00F8

.dw			0xF8F8					;netisknutelny znak 
.dw			0xF8F8
.dw			0xF8F8
.dw			0x00F8

.dw			0xF8F8					;netisknutelny znak 
.dw			0xF8F8
.dw			0xF8F8
.dw			0x00F8

.dw			0xF8F8					;netisknutelny znak 
.dw			0xF8F8
.dw			0xF8F8
.dw			0x00F8

.dw			0xF8F8					;netisknutelny znak 
.dw			0xF8F8
.dw			0xF8F8
.dw			0x00F8

.dw			0xF8F8					;netisknutelny znak 
.dw			0xF8F8
.dw			0xF8F8
.dw			0x00F8

.dw			0xF8F8					;netisknutelny znak 
.dw			0xF8F8
.dw			0xF8F8
.dw			0x00F8

.dw			0xF8F8					;netisknutelny znak 
.dw			0xF8F8
.dw			0xF8F8
.dw			0x00F8

.dw			0xF8F8					;netisknutelny znak 
.dw			0xF8F8
.dw			0xF8F8
.dw			0x00F8

.dw			0xF8F8					;netisknutelny znak 
.dw			0xF8F8
.dw			0xF8F8
.dw			0x00F8

.dw			0xF8F8					;netisknutelny znak 
.dw			0xF8F8
.dw			0xF8F8
.dw			0x00F8

.dw			0xF8F8					;netisknutelny znak 
.dw			0xF8F8
.dw			0xF8F8
.dw			0x00F8

.dw			0xF8F8					;netisknutelny znak 
.dw			0xF8F8
.dw			0xF8F8
.dw			0x00F8

.dw			0xF8F8					;netisknutelny znak 
.dw			0xF8F8
.dw			0xF8F8
.dw			0x00F8

.dw			0xF8F8					;netisknutelny znak 
.dw			0xF8F8
.dw			0xF8F8
.dw			0x00F8

.dw			0xF8F8					;netisknutelny znak 
.dw			0xF8F8
.dw			0xF8F8
.dw			0x00F8

.dw			0xF8F8					;netisknutelny znak 
.dw			0xF8F8
.dw			0xF8F8
.dw			0x00F8

.dw			0xF8F8					;netisknutelny znak 
.dw			0xF8F8
.dw			0xF8F8
.dw			0x00F8

.dw			0xF8F8					;netisknutelny znak 
.dw			0xF8F8
.dw			0xF8F8
.dw			0x00F8

.dw			0x0000					; 
.dw			0x0000
.dw			0x0000
.dw			0x0000

.dw			0x2020					;!
.dw			0x2020
.dw			0x0020
.dw			0x0020

.dw			0x5050					;"
.dw			0x0050
.dw			0x0000
.dw			0x0000

.dw			0x5050					;#
.dw			0x50F8
.dw			0x50F8
.dw			0x0050

.dw			0x7020					;$
.dw			0x70A0
.dw			0x7028
.dw			0x0020

.dw			0xD8D0					;%
.dw			0x2010
.dw			0x9840
.dw			0x0018

.dw			0x5020					;&
.dw			0x6050
.dw			0x90A8
.dw			0x0068

.dw			0x2020					;
.dw			0x0040
.dw			0x0000
.dw			0x0000

.dw			0x2010					;(
.dw			0x4040
.dw			0x2040
.dw			0x0010

.dw			0x2040					;)
.dw			0x1010
.dw			0x2010
.dw			0x0040

.dw			0x2000					;*
.dw			0x70A8
.dw			0x20A8
.dw			0x0000

.dw			0x2000					;+
.dw			0xF820
.dw			0x2020
.dw			0x0000

.dw			0x0000					;,
.dw			0x0000
.dw			0x4040
.dw			0x0080

.dw			0x0000					;-
.dw			0xF800
.dw			0x0000
.dw			0x0000

.dw			0x0000					;.
.dw			0x0000
.dw			0x0000
.dw			0x0040

.dw			0x0800					;/
.dw			0x2010
.dw			0x8040
.dw			0x0000

.dw			0x8870					;0
.dw			0xA898
.dw			0x88C8
.dw			0x0070

.dw			0x6020					;1
.dw			0x2020
.dw			0x2020
.dw			0x0070

.dw			0x8870					;2
.dw			0x3008
.dw			0x8040
.dw			0x00F8

.dw			0x08F8					;3
.dw			0x3010
.dw			0x8808
.dw			0x0070

.dw			0x3010					;4
.dw			0x9050
.dw			0x10F8
.dw			0x0010

.dw			0x80F8					;5
.dw			0x08F0
.dw			0x8808
.dw			0x0070

.dw			0x4038					;6
.dw			0xF080
.dw			0x8888
.dw			0x0070

.dw			0x08F8					;7
.dw			0x2010
.dw			0x4040
.dw			0x0040

.dw			0x8870					;8
.dw			0x7088
.dw			0x8888
.dw			0x0070

.dw			0x8870					;9
.dw			0x7088
.dw			0x1008
.dw			0x00E0

.dw			0x0000					;:
.dw			0x0000
.dw			0x0040
.dw			0x0040

.dw			0x0000					;;
.dw			0x0020
.dw			0x2020
.dw			0x0040

.dw			0x2010					;<
.dw			0x8040
.dw			0x2040
.dw			0x0010

.dw			0x0000					;=
.dw			0x00F8
.dw			0x00F8
.dw			0x0000

.dw			0x2040					;>
.dw			0x0810
.dw			0x2010
.dw			0x0040

.dw			0x8870					;?
.dw			0x1008
.dw			0x0020
.dw			0x0020

.dw			0x8870					;@
.dw			0x6808
.dw			0xA8A8
.dw			0x0070

.dw			0x5020					;A
.dw			0x8888
.dw			0x88F8
.dw			0x0088

.dw			0x88F0					;B
.dw			0xF088
.dw			0x8888
.dw			0x00F0

.dw			0x8870					;C
.dw			0x8080
.dw			0x8880
.dw			0x0070

.dw			0x48F0					;D
.dw			0x4848
.dw			0x4848
.dw			0x00F0

.dw			0x80F8					;E
.dw			0xF080
.dw			0x8080
.dw			0x00F8

.dw			0x80F8					;F
.dw			0xF080
.dw			0x8080
.dw			0x0080

.dw			0x8070					;G
.dw			0x8080
.dw			0x8898
.dw			0x0078

.dw			0x8888					;H
.dw			0xF888
.dw			0x8888
.dw			0x0088

.dw			0x2070					;I
.dw			0x2020
.dw			0x2020
.dw			0x0070

.dw			0x0808					;J
.dw			0x0808
.dw			0x8888
.dw			0x0070

.dw			0x9088					;K
.dw			0xC0A0
.dw			0x90A0
.dw			0x0088

.dw			0x8080					;L
.dw			0x8080
.dw			0x8080
.dw			0x00F8

.dw			0xD888					;M
.dw			0xA8A8
.dw			0x8888
.dw			0x0088

.dw			0x8888					;N
.dw			0xB8C8
.dw			0x8898
.dw			0x0088

.dw			0x8870					;O
.dw			0x8888
.dw			0x8888
.dw			0x0070

.dw			0x88F0					;P
.dw			0xF088
.dw			0x8080
.dw			0x0080

.dw			0x8870					;Q
.dw			0x8888
.dw			0x90B8
.dw			0x0068

.dw			0x88F0					;R
.dw			0xF088
.dw			0x90B0
.dw			0x0088

.dw			0x8870					;S
.dw			0x7080
.dw			0x8808
.dw			0x0070

.dw			0x20F8					;T
.dw			0x2020
.dw			0x2020
.dw			0x0020

.dw			0x8888					;U
.dw			0x8888
.dw			0x8888
.dw			0x0070

.dw			0x8888					;V
.dw			0x5088
.dw			0x2050
.dw			0x0020

.dw			0x8888					;W
.dw			0xA888
.dw			0xA8A8
.dw			0x0050

.dw			0x8888					;X
.dw			0x2050
.dw			0x8850
.dw			0x0088

.dw			0x8888					;Y
.dw			0x2050
.dw			0x2020
.dw			0x0020

.dw			0x08F8					;Z
.dw			0x2010
.dw			0x8040
.dw			0x00F8

.dw			0x80E0					;[ 
.dw			0x8080
.dw			0x8080
.dw			0x00E0

.dw			0x8000					;\ 
.dw			0x2040
.dw			0x0810
.dw			0x0000

.dw			0x0838					;] 
.dw			0x0808
.dw			0x0808
.dw			0x0038

.dw			0x8870					;^ 
.dw			0x0000
.dw			0x0000
.dw			0x0000

.dw			0x0000					;_ 
.dw			0x0000
.dw			0x0000
.dw			0x00F8

.dw			0x2020					;'
.dw			0x0020
.dw			0x0000
.dw			0x0000

.dw			0x0000					;a
.dw			0x0870
.dw			0x8878
.dw			0x0078

.dw			0x8080					;b
.dw			0xC8B0
.dw			0x8888
.dw			0x00F0

.dw			0x0000					;c
.dw			0x8070
.dw			0x8880
.dw			0x0070

.dw			0x0808					;d
.dw			0x9868
.dw			0x8888
.dw			0x0078

.dw			0x0000					;e
.dw			0x8870
.dw			0x80F8
.dw			0x0070

.dw			0x4830					;f
.dw			0xE040
.dw			0x4040
.dw			0x0040

.dw			0x7800					;g
.dw			0x8888
.dw			0x0878
.dw			0x0070

.dw			0x8080					;h
.dw			0xC8B0
.dw			0x8888
.dw			0x0088

.dw			0x0020					;i
.dw			0x2060
.dw			0x2020
.dw			0x0070

.dw			0x0010					;j
.dw			0x1030
.dw			0x9010
.dw			0x0060

.dw			0x8080					;k
.dw			0xA090
.dw			0xA0C0
.dw			0x0090

.dw			0x2060					;l
.dw			0x2020
.dw			0x2020
.dw			0x0070

.dw			0x0000					;m
.dw			0xA8D0
.dw			0x88A8
.dw			0x0088

.dw			0x0000					;n
.dw			0xC8B0
.dw			0x8888
.dw			0x0088

.dw			0x0000					;o
.dw			0x8870
.dw			0x8888
.dw			0x0070

.dw			0x0000					;p
.dw			0x88F0
.dw			0x80F0
.dw			0x0080

.dw			0x0000					;q
.dw			0x9868
.dw			0x0878
.dw			0x0008

.dw			0x0000					;r
.dw			0xC8B0
.dw			0x8080
.dw			0x0080

.dw			0x0000					;s
.dw			0x8070
.dw			0x0870
.dw			0x00F0

.dw			0x4040					;t
.dw			0x40E0
.dw			0x4840
.dw			0x0030

.dw			0x0000					;u
.dw			0x8888
.dw			0x9888
.dw			0x0068

.dw			0x0000					;v
.dw			0x8888
.dw			0x5088
.dw			0x0020

.dw			0x0000					;w
.dw			0x8888
.dw			0xA8A8
.dw			0x0050

.dw			0x0000					;x
.dw			0x5088
.dw			0x5020
.dw			0x0088

.dw			0x0000					;y
.dw			0x8888
.dw			0x0878
.dw			0x0070

.dw			0x0000					;z
.dw			0x10F8
.dw			0x4020
.dw			0x00F8

.dw			0x2010					;{
.dw			0x4020
.dw			0x2020
.dw			0x0010

.dw			0x2020					;|
.dw			0x2020
.dw			0x2020
.dw			0x0020

.dw			0x1020					;}
.dw			0x0810
.dw			0x1010
.dw			0x0020

.dw			0xB068					;~
.dw			0x0000
.dw			0x0000
.dw			0x0000

.DSEG                        ; Start data segment 
.dw			0x0707
